"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.toMarked = toMarked;
exports.default = exports.TreeBasic = exports.version = void 0;

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _TreeContext = _interopRequireDefault(require("./TreeContext"));

var _Node2 = _interopRequireDefault(require("./Node"));

var _TreeNode = _interopRequireDefault(require("./TreeNode"));

var version = "1.0.1";
exports.version = version;

function toMarked(array) {
  var marked = Object.create(null);
  array.forEach(function (value) {
    marked[value] = true;
  });
  return marked;
}

var TreeBasic = /*#__PURE__*/function (_React$Component) {
  (0, _inheritsLoose2.default)(TreeBasic, _React$Component);

  TreeBasic.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps) {
    return {
      expandedIds: nextProps.expandedIds,
      expandedMap: toMarked(nextProps.expandedIds || [])
    };
  };

  function TreeBasic(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    _this.state = {
      expandedIds: [],
      expandedMap: {}
    };
    return _this;
  }

  var _proto = TreeBasic.prototype;

  _proto.getRootNode = function getRootNode() {
    var _Node;

    var _this$props = this.props,
        rootId = _this$props.rootId,
        idField = _this$props.idField,
        pidField = _this$props.pidField,
        leafField = _this$props.leafField;
    var node = new _Node2.default((_Node = {}, _Node[idField] = rootId, _Node[pidField] = null, _Node[leafField] = false, _Node), null, this.props, this.state);
    return node;
  };

  _proto.getContext = function getContext() {
    return {
      tree: this
    };
  };

  _proto.render = function render() {
    var _classNames;

    var _this$props2 = this.props,
        prefixCls = _this$props2.prefixCls,
        className = _this$props2.className,
        style = _this$props2.style,
        Component = _this$props2.rootComponent,
        itemRender = _this$props2.itemRender,
        loadData = _this$props2.loadData;

    if (!itemRender) {
      throw new Error("react-widget-tree-basic: itemRender cannot be empty.");
    }

    if (!loadData) {
      throw new Error("react-widget-tree-basic: loadData cannot be empty.");
    }

    var classes = (0, _classnames.default)((_classNames = {}, _classNames[prefixCls] = true, _classNames[className] = className, _classNames));
    return /*#__PURE__*/_react.default.createElement(_TreeContext.default.Provider, {
      value: this.getContext()
    }, /*#__PURE__*/_react.default.createElement(Component, {
      className: classes,
      style: style
    }, /*#__PURE__*/_react.default.createElement(_TreeNode.default, {
      node: this.getRootNode(),
      isRoot: true
    })));
  };

  return TreeBasic;
}(_react.default.Component);

exports.TreeBasic = TreeBasic;
(0, _defineProperty2.default)(TreeBasic, "defaultProps", {
  prefixCls: "rw-tree",
  rootId: null,
  idField: "id",
  leafField: "leaf",
  pidField: "pid",
  maxDepth: 99,
  //最大层级99   Number.MAX_VALUE
  asyncTestDelay: 16,
  expandedIds: [],
  childrenRender: function childrenRender(props) {
    if (!props.expanded) return null;
    return props.getChildren();
  },
  rootComponent: "div"
});
var _default = TreeBasic;
exports.default = _default;