import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import React from "react";
import classNames from "classnames";
import TreeContext from "./TreeContext";
import Node from "./Node";
import TreeNode from "./TreeNode";
export var version = "1.0.1";
export function toMarked(array) {
  var marked = Object.create(null);
  array.forEach(function (value) {
    marked[value] = true;
  });
  return marked;
}
export var TreeBasic = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(TreeBasic, _React$Component);

  TreeBasic.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps) {
    return {
      expandedIds: nextProps.expandedIds,
      expandedMap: toMarked(nextProps.expandedIds || [])
    };
  };

  function TreeBasic(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    _this.state = {
      expandedIds: [],
      expandedMap: {}
    };
    return _this;
  }

  var _proto = TreeBasic.prototype;

  _proto.getRootNode = function getRootNode() {
    var _Node;

    var _this$props = this.props,
        rootId = _this$props.rootId,
        idField = _this$props.idField,
        pidField = _this$props.pidField,
        leafField = _this$props.leafField;
    var node = new Node((_Node = {}, _Node[idField] = rootId, _Node[pidField] = null, _Node[leafField] = false, _Node), null, this.props, this.state);
    return node;
  };

  _proto.getContext = function getContext() {
    return {
      tree: this
    };
  };

  _proto.render = function render() {
    var _classNames;

    var _this$props2 = this.props,
        prefixCls = _this$props2.prefixCls,
        className = _this$props2.className,
        style = _this$props2.style,
        Component = _this$props2.rootComponent,
        itemRender = _this$props2.itemRender,
        loadData = _this$props2.loadData;

    if (!itemRender) {
      throw new Error("react-widget-tree-basic: itemRender cannot be empty.");
    }

    if (!loadData) {
      throw new Error("react-widget-tree-basic: loadData cannot be empty.");
    }

    var classes = classNames((_classNames = {}, _classNames[prefixCls] = true, _classNames[className] = className, _classNames));
    return /*#__PURE__*/React.createElement(TreeContext.Provider, {
      value: this.getContext()
    }, /*#__PURE__*/React.createElement(Component, {
      className: classes,
      style: style
    }, /*#__PURE__*/React.createElement(TreeNode, {
      node: this.getRootNode(),
      isRoot: true
    })));
  };

  return TreeBasic;
}(React.Component);

_defineProperty(TreeBasic, "defaultProps", {
  prefixCls: "rw-tree",
  rootId: null,
  idField: "id",
  leafField: "leaf",
  pidField: "pid",
  maxDepth: 99,
  //最大层级99   Number.MAX_VALUE
  asyncTestDelay: 16,
  expandedIds: [],
  childrenRender: function childrenRender(props) {
    if (!props.expanded) return null;
    return props.getChildren();
  },
  rootComponent: "div"
});

export default TreeBasic;