interface NodeOptions {
    rootId?: null | string | number;
    idField?: string;
    pidField?: string;
    leafField?: string;
}
interface NodeState {
    expandedMap?: Record<string, boolean>;
}
export default class Node<T = Record<string, any>> {
    id: string | number;
    pid: string | number;
    leaf: boolean;
    data: T;
    loading: boolean;
    root: boolean;
    expanded: boolean;
    depth: number;
    constructor(data: T, parentNode: Node | null, options?: NodeOptions, state?: NodeState);
    getId(): string | number;
    getDepth(): number;
    setDepth(depth: number): void;
    getData(): T;
    isRoot(): boolean;
    isLeaf(): boolean;
    setExpanded(expanded: boolean): void;
    isExpanded(): boolean;
    setLoading(loading: boolean): void;
    isLoading(): boolean;
}
export {};
