import React from "react";
import TreeContext, { ContextValue } from "./TreeContext";
import Node from "./Node";
export declare type DataType = Record<string, any>;
export declare type renderProps<T> = Omit<TreeNodeProps<T>, "render" | "childrenRender">;
export interface TreeNodeProps<T = DataType> {
    node: Node<T>;
    isRoot: boolean;
    render?: (props: renderProps<T>, nodeItem: React.ReactNode, children: React.ReactNode) => React.ReactNode;
}
export interface TreeNodeState {
    isLoading: boolean;
}
declare class TreeNode<T> extends React.Component<TreeNodeProps<T>, TreeNodeState> {
    static defaultProps: {
        node: {};
        isRoot: boolean;
    };
    static contextType: React.Context<ContextValue<{}>>;
    context: ContextValue<T>;
    constructor(props: TreeNodeProps<T>, context: React.ContextType<typeof TreeContext>);
    getTree(): import(".").TreeBasic<T>;
    getTreeProps(): Readonly<import(".").TreeBasicProps<T>> & Readonly<{
        children?: React.ReactNode;
    }>;
    getNodeList(list: T[]): JSX.Element[];
    loadNodeChildren(): {} | null | undefined;
    renderNodeChildren(): {} | null | undefined;
    render(): {} | null | undefined;
}
export default TreeNode;
